H2O Wave - error while running hello_world

I have followed instructions provided in the H2O documentation, it works like a charm in my windows local machine but it gives me error on my lab machine (Ubuntu server)
below is the error, I have searched this error on internet and couldn’t get a solution, so looking for your help ASAP as I am very much excited to build my first dashboard app using Wave :slight_smile:
You guys are doing amazing stuff!!!

BTW… do we have H2O Wave docker image please ?

Waved is working fine, but while running hello_world.py it gives this below error message:
Appreciate your quick help here !!

Blockquote

~/wave-apps$ python3.8 hello_world.py
Traceback (most recent call last):
File “/home/sacindul/.local/lib/python3.8/site-packages/httpx/_exceptions.py”, line 326, in map_exceptions
yield
File “/home/sacindul/.local/lib/python3.8/site-packages/httpx/_client.py”, line 861, in _send_single_request
(status_code, headers, stream, ext) = transport.request(
File “/home/sacindul/.local/lib/python3.8/site-packages/httpcore/_sync/http_proxy.py”, line 112, in request
return self._forward_request(
File “/home/sacindul/.local/lib/python3.8/site-packages/httpcore/_sync/http_proxy.py”, line 165, in _forward_request
(status_code, headers, stream, ext) = connection.request(
File “/home/sacindul/.local/lib/python3.8/site-packages/httpcore/_sync/connection.py”, line 106, in request
return self.connection.request(method, url, headers, stream, ext)
File “/home/sacindul/.local/lib/python3.8/site-packages/httpcore/_sync/http11.py”, line 72, in request
) = self._receive_response(timeout)
File “/home/sacindul/.local/lib/python3.8/site-packages/httpcore/_sync/http11.py”, line 133, in _receive_response
event = self._receive_event(timeout)
File “/home/sacindul/.local/lib/python3.8/site-packages/httpcore/_sync/http11.py”, line 169, in _receive_event
event = self.h11_state.next_event()
File “/usr/lib/python3.8/contextlib.py”, line 131, in exit
self.gen.throw(type, value, traceback)
File “/home/sacindul/.local/lib/python3.8/site-packages/httpcore/_exceptions.py”, line 12, in map_exceptions
raise to_exc(exc) from None
httpcore.RemoteProtocolError: can’t handle event type ConnectionClosed when role=SERVER and state=SEND_RESPONSE

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
File “hello_world.py”, line 14, in
page.save()
File “/home/sacindul/.local/lib/python3.8/site-packages/h2o_wave/core.py”, line 541, in save
self.site._save(self.url, p)
File “/home/sacindul/.local/lib/python3.8/site-packages/h2o_wave/core.py”, line 603, in _save
res = self._http.patch(f’{_config.hub_address}{url}’, content=patch)
File “/home/sacindul/.local/lib/python3.8/site-packages/httpx/_client.py”, line 1062, in patch
return self.request(
File “/home/sacindul/.local/lib/python3.8/site-packages/httpx/_client.py”, line 733, in request
return self.send(
File “/home/sacindul/.local/lib/python3.8/site-packages/httpx/_client.py”, line 767, in send
response = self._send_handling_auth(
File “/home/sacindul/.local/lib/python3.8/site-packages/httpx/_client.py”, line 805, in _send_handling_auth
response = self._send_handling_redirects(
File “/home/sacindul/.local/lib/python3.8/site-packages/httpx/_client.py”, line 837, in _send_handling_redirects
response = self._send_single_request(request, timeout)
File “/home/sacindul/.local/lib/python3.8/site-packages/httpx/_client.py”, line 861, in _send_single_request
(status_code, headers, stream, ext) = transport.request(
File “/usr/lib/python3.8/contextlib.py”, line 131, in exit
self.gen.throw(type, value, traceback)
File “/home/sacindul/.local/lib/python3.8/site-packages/httpx/_exceptions.py”, line 343, in map_exceptions
raise mapped_exc(message, **kwargs) from exc # type: ignore
httpx.RemoteProtocolError: can’t handle event type ConnectionClosed when role=SERVER and state=SEND_RESPONSE

Blockquote

We have no known issues like this (my dev box is Ubuntu + Python 3.8.6, for example).

This seems to be related to https://github.com/encode/httpx/issues/96

Do you mind providing more details about your Ubuntu and Python environment, virtualenv/conda, and so on?

Thanks for your response Prithvi

uname -a:
Linux beavis 4.4.0-185-generic #215-Ubuntu SMP Mon Jun 8 21:53:19 UTC 2020 x86_64 x86_64 x86_64 GNU/Linux

python3.8 --version
Python 3.8.7

not using anaconda on this machine.
also not using venv

Actually to avoid these issues, it would be much better you provide an image for wave

does wave server requires to be exposed to internet by any chance ?
or do I need to take care of proxy settings to avoid this issue on my remote server ?

I am getting a similar error on both linux/windows Prithvi.

@Sai @anilmaddu Help me diagnose what’s happening at your end. It would be good if you can post a detailed narrative of how exactly you’re starting the Wave daemon and your wave app/script - a step-by-step walkthrough. As long as your hello_world.py can communicate with the Wave daemon’s IP, you should be fine.

I’m also not sure if this has to do with httpx and Python 3.8.7, since that version was released less than a month ago.